####pbP[W̃CXg[
install.packages(c("pls","C50","randomForest","nnet","kernlab","class","adabag","caret","e1071"),dep=TRUE)
library(pls)
library(e1071)
library(C50)
library(randomForest)
library(nnet)
library(rpart)
library(kernlab)
library(class)
library(adabag)
install.packages("h2o",repos=(c("http://s3.amazonaws.com/h2o-release/h2o/rel-kahan/5/R",getOption("repos"))))
library(h2o)
localH2O = h2o.init()
data(spam)
nr<-nrow(spam)
k=10 #JԂ
m=13
res<-matrix(0,k,m)
ta<-matrix(0,2,2)
cv<-pls::cvsegments(nr,k=k) #library(pls)
for(i in 1:k){
  cnum<-cv[[i]]
  x<-as.matrix(spam[-cnum,-58])
  y<-spam[-cnum,58]
  xx<-as.matrix(spam[cnum,-58])
  yy<-spam[cnum,58]
  N<-length(cnum)
  ####k-NN @
  kn<-knn(x,xx,y,k=7)
  res[i,1]<-sum(diag(table(yy,kn)))/N
  ####Naive Bayes @
  nai<- naiveBayes(type~.,data=spam[-cnum,])
  naip <- predict(nai,spam[cnum,])
  res[i,2]<-sum(diag(table(spam[cnum,58],naip)))/N
  ####rpart_Gini
  tr<-rpart(type~.,spam[-cnum,],cp=0)
  tt<-sort.list(tr$cptable[,5])[1]
  CP<-tr$cptable[,1][tt]
  tr<-rpart(type~.,spam[-cnum,],cp=CP)
  te<-predict(tr,spam[cnum,],type="class")
  res[i,3]<-sum(diag(table(yy,te)))/N
  ####rpart_information
  tr<-rpart(type~.,spam[-cnum,],cp=0,parms=list(split='information'))
  tt<-sort.list(tr$cptable[,5])[1]
  CP<-tr$cptable[,1][tt]
  tr<-rpart(type~.,spam[-cnum,],cp=CP)
  te<-predict(tr,spam[cnum,],type="class")
  res[i,4]<-sum(diag(table(yy,te)))/N
  ####C50
  tr<-C5.0(x,y)
  te<-predict(tr,xx)
  res[i,5]<-sum(diag(table(spam[cnum,58],te)))/N
  ####Bagging
  tr<-bagging(type~.,data=spam[-cnum,])
  te<-predict(tr,spam[cnum,-58])
  res[i,6]<-sum(diag(table(spam[cnum,58],te$class)))/N
  ####Boosting
  tr<-boosting(type~.,data=spam[-cnum,])
  te<-predict(tr,newdata=spam[cnum,-58])
  res[i,7]<-sum(diag(table(spam[cnum,58],te$class)))/N
  ####RF
  tr<-randomForest::randomForest(x,y,mytry=300)
  te<-predict(tr,xx)
  res[i,8]<-sum(diag(table(spam[cnum,58],te)))/N
  ####SVMPoly
  tr<-kernlab::ksvm(x,y,kernel ="polydot",scale=FALSE)
  te<-kernlab::predict(tr,xx)
  res[i,9]<-sum(diag(table(spam[cnum,58],te)))/N
  ####SVM_rbfdot
  tr<-kernlab::ksvm(x,y,kernel ="rbfdot",scale=TRUE)
  te<-kernlab::predict(tr,xx)
  res[i,10]<-sum(diag(table(spam[cnum,58],te)))/N
  ####logit
  tr0<-multinom(type~.,spam[-cnum,])
  te<-predict(tr0,spam[cnum,])
  res[i,11]<-sum(diag(table(spam[cnum,58],te)))/N
  ####av_NNET
  tr<-nnet(type~.,spam[-cnum,],size=5)
  te<-predict(tr,xx,type="class")
  res[i,12]<-sum(diag(table(spam[cnum,58],te)))/N
  ####DepLear
  spam.hex <- as.h2o(spam[-cnum,])
  tr<-h2o.deeplearning(x = 1:57,y = 58,training_frame = spam.hex,hidden = c(250,500,100,50,20),epochs=500)
  test.hex <- as.h2o(spam[cnum,])
  fit = h2o.predict(tr,newdata = test.hex[,-58])
  ta<-table(spam[cnum,58],as.data.frame(fit)[,1])
  res[i,13]<-sum(diag(ta))/sum(ta)
}
lab<-c("k_NN","NBayes","rp_Gini","rp_Entr","C50","Bagg","Boost","RF","svm_Poly","svm_Rad","Logit","aveNNet","DNNet")
colnames(res)<-lab
####Ђ}̍쐬
par(mar=c(3,5,1,1))
boxplot(res,horizontal = TRUE,las=2)
grid()
####σvbg
windows()
me<-apply(res,2,mean)
SD<-apply(res,2,sd)
ucl<-me+1.96*SD/sqrt(k) #95MԂ̏㑤El
lcl<-me-1.96*SD/sqrt(k) #95MԂ̉El
nc=ncol(res)
plot(1:nc,me,ylim=range(c(lcl-0.01,ucl)),xlab="")
grid()
arrows(1:nc,ucl,1:nc,lcl,length=.05,angle=90,code=3,col=2)
text(1:nc,lcl-0.01,colnames(res),col=1)
