####}8.10 ̃XNvg
library(randomForest)
library(kernlab)
library(glmnet)
library(pls)
library(flare)
library(lars)
library(caret)
library(mda)
library(LiblineaR)
library(e1071)
m=9; ku=100; k=10
nc<-ncol(akuta); nr<-nrow(akuta)
resu<-matrix(0,nr,m)
ta<-matrix(0,2,2)
na.res<-list()
for(rep in 1:ku){
  ncv<-pls::cvsegments(nr,k=k) #library(pls)
  for(j in 1:k){
    cnum<-ncv[[j]]
    X<- as.matrix(akuta[-cnum,-nc])
    Y<- as.matrix(akuta[-cnum,nc])
    Xtest<-as.matrix(akuta[cnum,-nc])
    ####lm
    LM<-step(lm(y~.,akuta[-cnum,]),trace=FALSE)
    resu[cnum,1]<-predict(LM,akuta[cnum,])
    ####randomForest
    rf<-randomForest(y~.,akuta[-cnum,],ntree=1000)
    resu[cnum,2]<-predict(rf,akuta[cnum,])
    ####KSVM
    svm<-ksvm(y~.,akuta[-cnum,],kernel ="rbfdot",scaled=FALSE)
    resu[cnum,3]<-predict(svm,akuta[cnum,])
    ####lars{lars}
    mod<-lars(X,Y,type = "lar")
    fited<-predict.lars(mod,Xtest,type="fit")$fit
    cn<-dim(fited)[2]
    resu[cnum,4]<-fited[,cn]
    ####alpha=0 ridge A
    mod<- glmnet( x=X,y=Y,alpha=0 )
    fitted<- predict(mod,newx=Xtest,s=min(mod$lambda))
    resu[cnum,5]<-fitted[,1]
    ####alpha=0.5 Elastic Net A
    mod<- glmnet( x=X,y=Y,alpha=0.5)
    fitted<- predict(mod,newx=Xtest,s=min(mod$lambda))
    resu[cnum,6]<-fitted[,1]
    ####alpha=1 lasso A
    mod<- glmnet( x=X,y=Y,alpha=1)
    fitted<- predict(mod,newx=Xtest,s=min(mod$lambda))
    resu[cnum,7]<-fitted[,1]
    ####Knnreg{caret}
    mod <- knnreg(X,Y,k=5)
    resu[cnum,8]<- predict(mod,Xtest)
    ####LiblineaR
    mod<-LiblineaR(X,Y,type=12,cost=1000,svr_eps=.01)
    resu[cnum,9]<-predict(mod,Xtest)$predictions
  }
  na.res[[rep]]<-resu
}
res1<-apply((na.res[[1]]-akuta$y)^2,2,mean)
res2<-mean((apply(na.res[[1]],1,mean)-akuta$y)^2)
for(i in 2:ku){
  res1<-rbind(res1,apply((na.res[[i]]-akuta$y)^2,2,mean))
  res2<-c(res2,mean((apply(na.res[[i]],1,mean)-akuta$y)^2))
}
colnames(res1)=c("lm","rf","svr","lars","ridge","e_net","lasso","knnreg","l2svr")
par(mar=c(4,6,1,1))
boxplot(cbind(res1),horizontal = TRUE,las=2,do.conf = TRUE,do.out = TRUE)
